%   Dataset and MATLAB Codes for Automatic Parking Controller with a Twin Artificial Neural Network Architecture
%   Copyright (C) 2019 Jaeyoung Moon
%   Jaeyoung Moon, et al. "Automatic Parking Controller with a Twin Artificial Neural Network Architecture", Mathematical Problems in Engineering. 
clc; clear all;

n = 0.54;
l = 2.52;
m = 0.54;
b = 0.8;
w = 1.0;

x_cart = [0 l+2*n l+2*n 0 0 ]-m;
y_cart = [-b -b b b -b];

i = 1;
figure(i)
hold on
path1 = [sprintf('data/data_'),num2str(i),sprintf('.txt')];
path2 = [sprintf('data/data_'),num2str(i),sprintf('.png')];

data = load(path1);
data = data';
SL = data(6,1);

plot(data(1,:),data(2,:), 'r', 'linewidth', 1)
for j = 1:2:size(data,2)
    X_cart = x_cart.*cos(data(4,j))-y_cart.*sin(data(4,j))+data(1,j);
    Y_cart = x_cart.*sin(data(4,j))+y_cart.*cos(data(4,j))+data(2,j);
    plot(X_cart, Y_cart, '-k');
end

p_x = [-1 0 0 SL SL 10];
p_y = [w w -w -w w w]-w;
plot(p_x,p_y, 'b',  'linewidth', 1); 

axis equal
set(gca,'FontSize',14)
xlabel('X (m)','Fontsize',14)
ylabel('Y (m)','Fontsize',14)
grid on

figure(i+1000)
subplot(2,1,1)
hold on
plot([0:0.1:(size(data,2)-1)/10],data(5,:), 'k',  'linewidth', 1); 

grid on
set(gca,'FontSize',14)
xlabel('Time (s)','Fontsize',14)
ylabel('Steering Angle (rad)','Fontsize',14)

subplot(2,1,2)
hold on
plot([0:0.1:(size(data,2)-1)/10],data(3,:), 'k',  'linewidth', 1); 
set(gca,'FontSize',14)
xlabel('Time (s)','Fontsize',14)
ylabel('Velocity (m/s)','Fontsize',14)
grid on